#version 450

in vec2 uv_out;
in vec3 normal_out;
in vec3 lighting;

out vec4 color;
out vec3 normals;

uniform sampler2D albedo_texture;
uniform vec4 tint;

highp float rand(vec2 co)
{
    highp float a = 12.9898;
    highp float b = 78.233;
    highp float c = 43758.5453;
    highp float dt= dot(co.xy ,vec2(a,b));
    highp float sn= mod(dt,3.14);
    return fract(sin(sn) * c);
}

void main() {
	vec4 albedo = texture(albedo_texture, uv_out);
	albedo *= tint;

	float chance = rand(vec2(floor(uv_out.x * 1024.), floor(uv_out.y * 1024.)));

	if (albedo.a < 1. && chance >= albedo.a) {
		discard;
	}

	color = albedo;
	normals = normal_out;
}