#version 450

in vec3 position;
in vec3 normal;
in vec2 uv;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;

uniform ivec3 light_offset;
uniform vec3 sun_light;

out vec2 uv_out;
out vec3 normal_out;
out vec3 lighting;

layout(r11f_g11f_b10f) uniform image3D lighting_map;

void main() {
	vec4 vertex_pos = model * vec4(position, 1.);

	lighting = vec3(0.8);
	uv_out = uv;

	normal_out = (transpose(inverse(mat3(model))) * normal) / 2. + 0.5;
	gl_Position = projection * view * vertex_pos;
}