#version 450

in vec2 uv_out;
in flat uint voxelTexture;
in vec3 normal_out;
in float lighting_out;

out vec4 color;
out vec3 normals;

uniform sampler2DArray voxelTextures;
uniform vec4 tint;

highp float rand(vec2 co)
{
    highp float a = 12.9898;
    highp float b = 78.233;
    highp float c = 43758.5453;
    highp float dt= dot(co.xy ,vec2(a,b));
    highp float sn= mod(dt,3.14);
    return fract(sin(sn) * c);
}

void main() {
	vec4 albedo = texture(voxelTextures, vec3(uv_out, voxelTexture));
	albedo *= tint;

	float chance = rand(vec2(floor(uv_out.x * 1024.), floor(uv_out.y * 1024.)));

	if (chance >= albedo.a) {
		discard;
	}

	color = vec4(albedo.rgb * lighting_out, 1.);
	normals = normal_out;
}